---
title: HTMLInputElement.setRangeText()
slug: Web/API/HTMLInputElement/setRangeText
tags:
  - API
  - HTML DOM
  - HTMLInputElement
  - Method
  - NeedsCompatTable
  - Reference
  - Text Field Selection API
---
<div>{{APIRef("HTML DOM")}}</div>

<p>The <strong><code>HTMLInputElement.setRangeText()</code></strong> method replaces a range of text in an {{HTMLElement("input")}} or {{HTMLElement("textarea")}} element with a new string.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>element</em>.setRangeText(<em>replacement</em>);
<em>element</em>.setRangeText(<em>replacement</em>, <em>start</em>, <em>end</em> [, <em>selectMode</em>]);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>replacement</code></dt>
 <dd>The string to insert.</dd>
 <dt><code>start</code> {{optional_inline}}</dt>
 <dd>The 0-based index of the first character to replace. Defaults to the current <code>selectionStart</code> value (the start of the user's current selection).</dd>
 <dt><code>end</code> {{optional_inline}}</dt>
 <dd>The 0-based index of the character <em>after</em> the last character to replace. Defaults to the current <code>selectionEnd</code> value (the end of the user's current selection).</dd>
 <dt><code>selectMode</code> {{optional_inline}}</dt>
 <dd>A string defining how the selection should be set after the text has been replaced. Possible values:
 <ul>
  <li><code>"select"</code> selects the newly inserted text.</li>
  <li><code>"start"</code>moves the selection to just before the inserted text.</li>
  <li><code>"end"</code> moves the selection to just after the inserted text.</li>
  <li><code>"preserve"</code> attempts to preserve the selection. This is the default.</li>
 </ul>
 </dd>
</dl>

<h2 id="Example">Example</h2>

<p>Click the button in this example to replace part of the text in the text box. The newly inserted text will be highlighted (selected) afterwards.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;input type="text" id="text-box" size="30" value="This text has NOT been updated."&gt;
&lt;button onclick="selectText()"&gt;Update text&lt;/button&gt;
</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js">function selectText() {
  const input = document.getElementById('text-box');
  input.focus();
  input.setRangeText('ALREADY', 14, 17, 'select');
}</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Example")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("HTML WHATWG", "forms.html#dom-textarea/input-setrangetext", "HTMLInputElement.setSelectionRange()")}}</td>
   <td>{{Spec2("HTML WHATWG")}}</td>
   <td>No change</td>
  </tr>
  <tr>
   <td>{{SpecName("HTML5 W3C", "forms.html#dom-textarea/input-setrangetext", "HTMLInputElement.setSelectionRange()")}}</td>
   <td>{{Spec2("HTML5 W3C")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.HTMLInputElement.setRangeText")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{HTMLElement("input")}}</li>
 <li>{{HTMLElement("textarea")}}</li>
 <li>{{domxref("HTMLInputElement")}}</li>
 <li>{{domxref("Selection")}}</li>
</ul>
